  
#version 3.7;
global_settings { assumed_gamma 2. }  

#include "colors.inc"
#include "metals.inc"    
#include "glass.inc"
#include "transforms.inc" // various geometric transformation macros


 

camera { orthographic location <0,0,-30> look_at<0.,-0.0,0> right 1*x  angle 30}  //   perspective 


light_source { <-10,20,-20>*80 color  rgb <1,1,1>     // shadowless
             //   area_light  <1,0,0>, <0,0,1>,4, 4   // jitter 
               } 
 light_source { <10,10,-20>*80 color White  shadowless} //  }    
 //light_source { <10,-10,-20>*200 color rgb <1,1,1> shadowless}
#declare colfond=White*0.8;
background{  colfond }       //  Black }   //

//=================================================== 
#declare fn1=   finish { ambient 0.4 diffuse 0.7 reflection 0.  phong 0. phong_size 2 };  
#declare fn=   finish { ambient 0.6 diffuse 0.2 reflection 0.1  phong 0.8 phong_size 20 }; 
#macro tex(col,finition) texture{  pigment{ col}    finish { finition} }    #end
#declare tabcol=array[11]{Blue,Red,Yellow*0.8,Cyan,SeaGreen,Magenta,Khaki,Pink,Aquamarine,Copper,Gold};
//=================================================== 

#macro tv(x1,y1,y2,r) 
      union{   triangle{ <x1-r,y1,0>,<x1+r,y1,0>,<x1+r,y2,0>} triangle{ <x1-r,y1,0>,<x1+r,y2,0>,<x1-r,y2,0>} }
#end 
#macro th(x1,x2,y1,r) 
      union{   triangle{ <x1,y1-r,0>,<x1,y1+r,0>,<x2,y1+r,0>} triangle{ <x1,y1-r,0>,<x2,y1-r,0>,<x2,y1+r,0>} }
#end

#macro rectbase(pt1,pt2,r) 
      union{ tv(pt1.x,pt1.y-r,pt2.y+r,r)  tv(pt2.x,pt1.y-r,pt2.y+r,r) 
             th(pt1.x-r,pt2.x+r,pt1.y,r)  th(pt1.x-r,pt2.x+r,pt2.y,r) 
            }
                                              
#end 
                              
//----------------- les rayons ; nb de composants ; couleur bords ---------------
#declare n=5 ;  //--- nombre de composants du noeud - 1  

#declare r=0.15; #declare r1=r/8;
#declare colbords=Black;  
//-------------------------------------------------------------------------------
#macro cache(i,j) object{box{<i,j,0>-<r+2*r1,r+2*r1>,<i,j,0>+<r+2*r1,r+2*r1>}  pigment{colfond}} #end    // 
#macro rectxy(pt1,pt2,col)
      union{ 
             // bande milieu 
             object{ rectbase(pt1, pt2,r ) tex(col,fn) }        // sphere{pt1,r pigment{Green}} sphere{pt2,r pigment{Green}}
             // les bords
             #local pt3= pt1+<-r-r1,-r-r1,0>;   #local pt4= pt2+<r+r1,r+r1,0>;
             #local pt5=pt1-<-r-r1,-r-r1,0> ;   #local pt6= pt2-<r+r1,r+r1,0>;  
             union{ object{rectbase(pt3, pt4,r1 )} object{rectbase( pt5,pt6,r1 )} tex(colbords,fn) }                   

            }
#end

//-------------------------------------------------------------------------------

 #macro rectij(i) rectxy(<-i,i,0> ,<i,2*n-i,0> ,tabcol[i])  #end  //--- i=1 .. n-1
 
 #declare fermx= object{ rectxy(<0,-1,0>,<n+1,2*n,0>,tabcol[0]) }; 
#declare fermy= object{ rectxy(<-n,0,0>,<n,n,0>,tabcol[n]) }; 
//============================== tracs ==================
/*   */ 

union{ 
        
     #for(k,1,n-1,1 )     //  sommets <-k,k>,<k,k>,<k,2*n-k>,<-k,2*n-k>
     difference{  object{ rectij(k)}
                  union{                                               
                         cache(-k,2*n-k-1) cache(k,2*n-k-1)                      // cots latraux dessous rectangle suivant ( k+1)
                         cache(-k,k+1) cache(k,k+1)                              //  
                         
                         #for(i,-k+2,k-2,1) cache(i,k)  cache(i,2*n-k) #end  // les cots horizontaux  audessous des prcdants
                        
                        }                                              
                 }
    #end  
      difference{ object{fermx}  union{cache(0,1) cache(0,2*n-1)}        }
      difference{ object{fermy}  union{    cache(0,0)   //  cache(-n+1,n)  cache(n-1,n)
                                        #for(i,-n+2,n-2,1)cache(i,n) #end 
                                        }        }  //  
      translate <-0.2,-1.5,0>*3
      scale  1.55-0.05*n
      }
  
       text {                                                      
           ttf "timrom.ttf" "AE" 0.15, 0   pigment {White*0.4 }
           scale 1   rotate <-15,10,0>  translate <-2.4,-2.5,0>*2.8
         }  
         
         
         // #for(i,k+2,2*n-k-2,1) cache(-k,i)  cache(k,i) #end   // cots latraux audessus des suivants (k+2 ...